// systemy.cpp : Defines the entry point for the console application.
//

#include "stdio.h"
#include "math.h"
#include<fstream.h>

#include "iostream.h"

#define M 100
#define N 100

typedef long double REAL;

typedef REAL* uREAL;
typedef REAL** uuREAL;
typedef REAL*** uuuREAL;


void getMem(uuuREAL *u)
{
int i,k;
	*u=new uuREAL [3];

	for (k=0;k<3;k++) (*u)[k]=new uREAL[M];
	
	for (k=0;k<3;k++)
	for (i=0;i<M;i++) (*u)[k][i]=new REAL[N];

}
void freeMem(uuuREAL *u)
{
int i,k;

	for (k=0;k<3;k++)
	for (i=0;i<M;i++) delete[] (*u)[k][i];

	for (k=0;k<3;k++) delete [](*u)[k];
	

	delete [] (*u);

}

REAL index(int i, int j,uuREAL K)
{
if (i<0) i=0;
if (i>M-1) i=M-2;
if (j<0) j=0;
if (j>N-1) j=N-2;
return K[i][j];

}


uuuREAL u,k1,k2,k3,k4,w;
REAL t, tau,h1,h2, D[3], r[3], a[3][3];

void f(uuuREAL u, REAL time, REAL timestep, int indx, uuREAL *o)
{
	int i,j;
	REAL pom;
	for (i=0;i<M;i++)
	 for (j=0;j<N;j++)
	 {
		 pom=D[indx]*((index(i+1,j,u[indx])-2*index(i,j,u[indx])+index(i-1,j,u[indx]))/(h1*h1)+
					(index(i,j+1,u[indx])-2*index(i,j,u[indx])+index(i,j-1,u[indx]))/(h2*h2))+
					u[indx][i][j]*(r[indx]-a[indx][0]*u[0][i][j]-a[indx][1]*u[1][i][j]-a[indx][2]*u[2][i][j]);
		 (*o)[i][j]=pom*timestep;
	 }
}

void prepare(uuREAL p,uuREAL q, REAL coef, uuREAL *o)
{
	int i,j;
	for (i=0;i<M;i++) 
	for (j=0;j<N;j++) (*o)[i][j]=p[i][j]+coef*q[i][j];

}

void RungKutt()
{
int i,j,k;

f(u,t,tau,0,&(k1[0]));
f(u,t,tau,1,&(k1[1]));
f(u,t,tau,2,&(k1[2]));

prepare(u[0],k1[0],0.5,&(w[0]));
prepare(u[1],k1[1],0.5,&(w[1]));
prepare(u[2],k1[2],0.5,&(w[2]));

f(w,t+tau/2,tau,0,&(k2[0]));
f(w,t+tau/2,tau,1,&(k2[1]));
f(w,t+tau/2,tau,2,&(k2[2]));


prepare(u[0],k2[0],0.5,&(w[0]));
prepare(u[1],k2[1],0.5,&(w[1]));
prepare(u[2],k2[2],0.5,&(w[2]));

f(w,t+tau/2,tau,0,&(k3[0]));
f(w,t+tau/2,tau,1,&(k3[1]));
f(w,t+tau/2,tau,2,&(k3[2]));

prepare(u[0],k3[0],1.0,&(w[0]));
prepare(u[1],k3[1],1.0,&(w[1]));
prepare(u[2],k3[2],1.0,&(w[2]));

f(w,t+tau,tau,0,&(k4[0]));
f(w,t+tau,tau,1,&(k4[1]));
f(w,t+tau,tau,2,&(k4[2]));

for (i=0;i<M;i++)
for (j=0;j<N;j++)
for (k=0;k<3;k++)
{
u[k][i][j]=u[k][i][j]+1.0/6.0*(k1[k][i][j]+2.0*k2[k][i][j]+2.0*k3[k][i][j]+k4[k][i][j]);
}
}


char strHead[1000]=
"# vtk DataFile Version 2.0\n"
"2D phase field model\n"
"ASCII\n"
"DATASET STRUCTURED_POINTS\n"
"DIMENSIONS       100      100        1\n"
"ORIGIN          0.0     0.0     0.0\n"
"SPACING           0.01000       0.01000       1.0000\n"
"POINT_DATA          10000\n"
"SCALARS scalars float\n"
"LOOKUP_TABLE default\n\n";

void writehead(FILE *f)
{
fprintf(f,strHead);

}

int main(int argc, char* argv[])
{

/*
uuREAL u[3],k1[3],k2[3],k3[3],k4[3],w[3];
REAL t, tau,h1,h2, D[3], r[3], a[3][3];
*/


	t = 0.0;
	tau = 0.01;
	h1=1.0/(M-1);
	h2=1.0/(N-1);

	D[0]=.0001;
	D[1]=.0001;
	D[2]=.0001;

	r[0]=1.0;
	r[1]=1.0;
	r[2]=1.0;

// spiraly
//	a[0][0]=1.0; a[0][1]=3.0; a[0][2]=6.0;
//	a[1][0]=6.5; a[1][1]=1.0; a[1][2]=3.5;
//	a[2][0]=2.9; a[2][1]=6.1; a[2][2]=1.0;

// ustaleni
//	a[0][0]=1.0; a[0][1]=2.0; a[0][2]=2.0;
//	a[1][0]=2.0; a[1][1]=1.0; a[1][2]=7.0;
//	a[2][0]=2.0; a[2][1]=7.5; a[2][2]=1.0;

// 
	a[0][0]=1.0; a[0][1]=3.0; a[0][2]=3.0;
	a[1][0]=3.0; a[1][1]=1.0; a[1][2]=3.0;
	a[2][0]=3.0; a[2][1]=3.1; a[2][2]=1.0;


	getMem(&u);
	getMem(&w);
	getMem(&k1);
	getMem(&k2);
	getMem(&k3);
	getMem(&k4);


	int i,j,k,l,m,w1,w2,w3;
	for (i=0;i<M;i++)
	 for (j=0;j<N;j++)
	 for (k=0;k<3;k++)
	 {
		u[k][i][j]=0;
		w[k][i][j]=0;
		k1[k][i][j]=0;
		k2[k][i][j]=0;
		k3[k][i][j]=0;
		k4[k][i][j]=0;

	 }

/*
REAL amplituda=0.01*sqrt(2);
//if (args<5) amplituda=1; else amplituda=atof(argv[4]);
		cout << "amplituda=" << amplituda << endl;

int l;
k=10;           //odmocnina z poctu ctvercu, na nez rozdelime nasi oblast Omega
l=5;            //delka strany ctverce, v nemz budou konst. poc. podm.


for (i=0;i<M;i++)
	for (j=0;j<N;j++)
	{
	u[0][i][j] = 1.0/7.0;
	u[1][i][j] = 1.0/7.0;
	u[2][i][j] = 1.0/7.0;
        switch (((i/l)+(j/l))%3)
        {
        case 0:
	u[0][i][j] = 1.0/7.0+amplituda;
        break;
        case 1:
	u[1][i][j] = 1.0/7.0+amplituda;
        break;
        case 2:
	u[2][i][j] = 1.0/7.0+amplituda;
        break;
	}
}
*/
		FILE *fin;
		unsigned char troj[50],r,g,b;
		REAL r1,g1,b1;
		char strname[100];

		fin=fopen("init3.ppm","rb");
		if (!fin){
				cout << "Nelze vytvoit soubor pro cteni." << endl;
				return 1;
		}

	fread(troj, 1, 15, fin);       //hlavicka

	for (i=0;i<M;i++)
	 for (j=0;j<N;j++)
	 {
		 u[0][i][j]=0;
		 u[1][i][j]=0;
		 u[2][i][j]=0;
		 fread(troj, 1, 3, fin);
		r=troj[0]; g=troj[1]; b=troj[2];
		
		k=0; if (g>r) k=1;
		if (b>troj[k]) k=2;				// nyni vim do jake barvy

		u[k][i][j]=(REAL)(r+g+b)*1.0/(3.0*255.0);
	 }

		

		fclose(fin);

		ofstream f1,f2,f3;


	k=0;

	m=0;
		while (t<1000.0) {

	
	if (k % 64 ==0) {
		cout << t <<endl;
		
		if (f1.is_open()) { 
			f1.close ();
		}

/*		if (f2.is_open()) { 
			f2.close ();
		}
		if (f3.is_open()) { 
			f3.close ();
		}
*/

		sprintf(strname,"x%05d.vtk",m);

		cout<< strname <<endl;
		f1.open (strname, ios::out);
		if (!f1) {
				cout << "Nelze vytvoit doasn soubor." << endl;
				return 1;
		};

/*		sprintf(strname,"y%4.1f.vtk",t);

		f2.open (strname, ios::out);
		if (!f2) {
				cout << "Nelze vytvoit doasn soubor." << endl;
				return 1;
		};
		sprintf(strname,"z%4.1f.vtk",t);

		f3.open (strname, ios::out);
		if (!f3) {
				cout << "Nelze vytvoit doasn soubor." << endl;
				return 1;
		};
*/

		f1 << strHead <<endl;
/*		f2 << strHead <<endl;
		f3 << strHead <<endl;
*/
	for (i=0;i<M;i++)
		for (j=0;j<N;j++)
		{
		r1=u[0][i][j];
		g1=u[1][i][j];
		b1=u[2][i][j];

//		l=1; if (r1>g1) l=0;
//		if (b1>u[l][i][j]) l=2;				// nyni vim do jake barvy
//		f1 << u[l][i][j]+l << " ";

		l=0; if (g1>r1) l=1;
		if (b1>u[l][i][j]) l=2;				// nyni vim do jake barvy
		f1 << u[l][i][j]+l << " ";

/*		f1 << u[0][i][j] << " ";
		f2 << u[1][i][j] << " ";
		f3 << u[2][i][j] << " ";
*/
		};
	        f1 << endl << endl;
//          f2 << endl << endl;
//	        f3 << endl << endl;

		m++;
	}
	
	
	RungKutt ();
	t=t+tau;

	k++;

	}

		if (f1.is_open()) { 
			f1.close ();
		}
/*		if (f2.is_open()) { 
			f2.close ();
		}
		if (f3.is_open()) { 
			f3.close ();
		}
 
*/





/* uklid */


	freeMem(&u);
	freeMem(&w);
	freeMem(&k1);
	freeMem(&k2);
	freeMem(&k3);
	freeMem(&k4);


	return 0;
}
